from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, String, Int

Process_Merged_Nodup_Sh_V0_1_0 = CommandToolBuilder(tool="process_merged_nodup.sh", base_command=["process_merged_nodup.sh"], inputs=[ToolInput(tag="in_ignore_leading_blanks", input_type=Boolean(optional=True), prefix="-b", doc=InputDocumentation(doc="Ignore leading blanks")), ToolInput(tag="in_check_input_sorted", input_type=Boolean(optional=True), prefix="-c", doc=InputDocumentation(doc="Check whether input is sorted")), ToolInput(tag="in_dictionary_order_blank", input_type=Boolean(optional=True), prefix="-d", doc=InputDocumentation(doc="Dictionary order (blank or alphanumeric only)")), ToolInput(tag="in_ignore_case", input_type=Boolean(optional=True), prefix="-f", doc=InputDocumentation(doc="Ignore case")), ToolInput(tag="in_general_numerical_sort", input_type=Boolean(optional=True), prefix="-g", doc=InputDocumentation(doc="General numerical sort")), ToolInput(tag="in_ignore_unprintable_characters", input_type=Boolean(optional=True), prefix="-i", doc=InputDocumentation(doc="Ignore unprintable characters")), ToolInput(tag="in_sort_key", input_type=Boolean(optional=True), prefix="-k", doc=InputDocumentation(doc="Sort key")), ToolInput(tag="in_sort_month", input_type=Boolean(optional=True), prefix="-M", doc=InputDocumentation(doc="Sort month")), ToolInput(tag="in_sort_numbers", input_type=Boolean(optional=True), prefix="-n", doc=InputDocumentation(doc="Sort numbers")), ToolInput(tag="in_output_to_file", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc="Output to file")), ToolInput(tag="in_key_separator", input_type=String(optional=True), prefix="-t", doc=InputDocumentation(doc="Key separator")), ToolInput(tag="in_reverse_sort_order", input_type=Boolean(optional=True), prefix="-r", doc=InputDocumentation(doc="Reverse sort order")), ToolInput(tag="in_stable_sort_ties", input_type=Boolean(optional=True), prefix="-s", doc=InputDocumentation(doc="Stable (don't sort ties alphabetically)")), ToolInput(tag="in_suppress_duplicate_lines", input_type=Boolean(optional=True), prefix="-u", doc=InputDocumentation(doc="Suppress duplicate lines")), ToolInput(tag="in_lines_terminated_newline", input_type=Boolean(optional=True), prefix="-z", doc=InputDocumentation(doc="Lines are terminated by NUL, not newline")), ToolInput(tag="in_mst", input_type=Boolean(optional=True), prefix="-mST", doc=InputDocumentation(doc="Ignored for GNU compatibility")), ToolInput(tag="in_preset_pairs_mergednodups", input_type=String(optional=True), prefix="-p", doc=InputDocumentation(doc="preset: pairs, merged_nodups, old_merged_nodups, gff, bed, sam, vcf, psltbl [gff]")), ToolInput(tag="in_e", input_type=Int(optional=True), prefix="-e", doc=InputDocumentation(doc="end1 column; can be identical to '-b' [5]")), ToolInput(tag="in_v", input_type=Int(optional=True), prefix="-v", doc=InputDocumentation(doc="end2 column; can be identical to '-u' [null or identical to the start2 specified by -u]")), ToolInput(tag="in_delimiter_space_instead", input_type=Boolean(optional=True), prefix="-T", doc=InputDocumentation(doc="delimiter is space instead of tab.")), ToolInput(tag="in_query_region_string", input_type=Boolean(optional=True), prefix="-L", doc=InputDocumentation(doc="query region is not a string but a file listing query regions")), ToolInput(tag="in_skip_first_lines", input_type=Int(optional=True), prefix="-S", doc=InputDocumentation(doc="skip first INT lines [0]")), ToolInput(tag="in_symbol_query_region", input_type=String(optional=True), prefix="-w", doc=InputDocumentation(doc="symbol for query region separator [|]")), ToolInput(tag="in_zerobased_coordinate", input_type=Boolean(optional=True), prefix="-0", doc=InputDocumentation(doc="zero-based coordinate")), ToolInput(tag="in_print_only_lines", input_type=Boolean(optional=True), prefix="-H", doc=InputDocumentation(doc="print only the header lines")), ToolInput(tag="in_print_only_number", input_type=Boolean(optional=True), prefix="-B", doc=InputDocumentation(doc="print only the number of bgzf blocks for existing chromosome (pairs)")), ToolInput(tag="in_print_only_region", input_type=Boolean(optional=True), prefix="-W", doc=InputDocumentation(doc="print only the region split character")), ToolInput(tag="in_only_check_occurs", input_type=Boolean(optional=True), prefix="-Y", doc=InputDocumentation(doc="Only check if the file is a triangle (i.e. a chromosome pair occurs only in one direction (e.g. if chr1|chr2 exists, chr2|chr1 doesn't))")), ToolInput(tag="in_list_chromosome_names", input_type=Boolean(optional=True), prefix="-l", doc=InputDocumentation(doc="list chromosome names")), ToolInput(tag="in_autoflip_query_pair", input_type=Boolean(optional=True), prefix="-a", doc=InputDocumentation(doc="autoflip query when the matching chromosome pair doesn't exist")), ToolInput(tag="in_nrugmcszbdfimstokt", input_type=Boolean(optional=True), prefix="-nrugMcszbdfimSTokt", doc=InputDocumentation(doc="")), ToolInput(tag="in_pair_ix", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_sort", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_in_dot_pairs_do_tgz", input_type=String(), position=1, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_output_to_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_to_file", type_hint=File()), doc=OutputDocumentation(doc="Output to file"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Process_Merged_Nodup_Sh_V0_1_0().translate("wdl", allow_empty_container=True)

